#property copyright "Copyright  2009, Condor FX "
#property link      "support@buyload.ru"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Blue
#property indicator_color2 Lime
#property indicator_color3 Red

extern int Period_CCI = 30;
int gi_80 = 5;
double gd_84 = 0.618;
double gd_92;
double gd_100;
double gd_108;
double gd_116;
double gd_124;
double gd_132;
double gd_140;
double gd_148;
double gd_156;
double gd_164;
double gd_172;
double gd_180;
double gd_188;
double gd_196;
double gd_204;
double Bufer_1[];
double Bufer_2[];
double Bufer_3[];

int init() {
   IndicatorBuffers(8);
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID);
   IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS));
   IndicatorShortName("dpt6: " + Period_CCI);
   SetIndexBuffer(0, Bufer_1);
   SetIndexBuffer(1, Bufer_2);
   SetIndexBuffer(2, Bufer_3);
   SetIndexLabel(0, "dpt6");
   gd_196 = gd_84 * gd_84;
   gd_204 = gd_196 * gd_84;
   gd_140 = -gd_204;
   gd_148 = 3.0 * (gd_196 + gd_204);
   gd_156 = -3.0 * (2.0 * gd_196 + gd_84 + gd_204);
   gd_164 = 3.0 * gd_84 + 1.0 + gd_204 + 3.0 * gd_196;
   gd_172 = gi_80;
   if (gd_172 < 1.0) gd_172 = 1;
   gd_172 = (gd_172 - 1.0) / 2.0 + 1.0;
   gd_180 = 2 / (gd_172 + 1.0);
   gd_188 = 1 - gd_180;
   return (0);
}

int start() {
   int IndCounted = IndicatorCounted();
   if (IndCounted < 0) return (-1);
   if (IndCounted > 0) IndCounted--;
   int li_0 = Bars - IndCounted;
   for (int i = Bars - 1; i >= 0; i--) {
      Bufer_1[i] = iCCI(NULL, 0, Period_CCI, PRICE_TYPICAL, i);
      gd_92 = gd_180 * Bufer_1[i] + gd_188 * gd_92;
      gd_100 = gd_180 * gd_92 + gd_188 * gd_100;
      gd_108 = gd_180 * gd_100 + gd_188 * gd_108;
      gd_116 = gd_180 * gd_108 + gd_188 * gd_116;
      gd_124 = gd_180 * gd_116 + gd_188 * gd_124;
      gd_132 = gd_180 * gd_124 + gd_188 * gd_132;
      Bufer_1[i] = gd_140 * gd_132 + gd_148 * gd_124 + gd_156 * gd_116 + gd_164 * gd_108;
      if (Bufer_1[i] >= 0.0) Bufer_2[i] = Bufer_1[i];
      else Bufer_2[i] = 0;
      if (Bufer_1[i] < 0.0) Bufer_3[i] = Bufer_1[i];
      else Bufer_3[i] = 0;
   }
   return (0);
}